{                                                                             }
{   Last modified: 23/01/96                                                   }
{                                                                             }
{                     *******************************                         }
{                     *      Ruslan Bondarenko      *                         }
{                     *******************************                         }
{                     *      My Pascal Library      *                         }
{                     *            (BPL)            *                         }
{                     *          CopyRight          *                         }
{                     *  Dniepr, 2:464/39@fidonet   *                         }
{                     *                             *                         }
{                     *           1995-96           *                         }
{                     *******************************                         }

{  ᮢ襭⢮ TResourceFile  ⠭⭮  Objects.pas
   ⭮ TResourceFile   ⢥ ⮪,
       쥪 ࠥ ⠫ 쥪⮢ 
  ᫨    稭  맢 ⮤ Flush (⪫祭
  ⠭, RunError),     .

  ! TObjectBase    쥪 ஢ 
  ࠭ ⠫,  室  Flush, ࠦ
   ,   ⮬ ⮫쪮 뢠 ᠬ 쥪.
   뢠 ⮤ Flush  易⥫쭮.  맮 
  Init ⥫  ࠬ sPage -  ࠧ ࠭
   ࠧ饭  쥪⮢.   sPage, ⥬ ०
  㤥 ந  ⠫    ॥ 㤥
  ࠡ ணࠬ   쥪⮢.
   Page   " 室".

  + TObjectBase  ࠡ   (   
   ᪮쪮 ணࠬ   ० ⥭ ⠪  )
   ⮣  맢 ⮤ Lock, ந 室 ⢨
   ᮬ,  ⥬ UnLock.  맮 Lock 室 ஢
   ErrorInfo, ..    ஢ 㣨 ਫ

-- ਬ 1 -------------------------------------
  with DB^ do
  begin
    Lock;
    if ErrorInfo = 0 then
     begin
      Put(New(PNewObject, Init))
      Unlock;
     end
     else Reset;
  end;
-------------------------------------------------

  +  TObjectBase  ⮤ SearchKey

-- ਬ 2 -------------------------------------
  var SearchVar: TSearchMode;
      MyObject: TMyObject;
  begin
    with DB^ do
    begin
      SearchVar := mSearchFirst;
      I := SearchKey('My Object', SearchVar);
      while I <> 0 do
      begin
        SearchVar := mSearchNext;
        MyObject := TMyObject(Get(I));
        I := SearchKey('My Object', SearchVar);
      end;
    end;
  end;
-------------------------------------------------

  +  ࠡ  Dos/DPMI/Win

  *  ⠫쭠 ࠡ c TObjectBase ᮮ⢥ TResourceFile

}
unit OBase;
interface
uses
    Objects;


type

  TSearchMode = (mSearchFirst, mSearchNext);

{ TObjectCollection object }

  PObjectCollection = ^TObjectCollection;
  TObjectCollection = object(TStringCollection)
    procedure FreeItem(Item: Pointer); virtual;
    function GetItem(var S: TStream): Pointer; virtual;
    function KeyOf(Item: Pointer): Pointer; virtual;
    procedure PutItem(var S: TStream; Item: Pointer); virtual;
  end;

{ TObjectBase object }
  PObjectBase = ^TObjectBase;

  TObjectBase = object(TObject)
    Stream     : PStream; {R/O}
    Modified   : Boolean; {R/O}
    Page       : LongInt; {R/W}
    Status     : Integer; {R/O}
    ErrorInfo  : Integer; {R/O}
    constructor Init(AStream: PStream; sPage: LongInt);
    destructor  Done; virtual;
    procedure   Error(sStatus, sErrorInfo : Integer); virtual;
    procedure   Reset;
    function    Refresh : Boolean;virtual;
    function    Count: Integer;virtual;
    procedure   Delete(Key: String);
    procedure   Flush;virtual;
    function    Get(Key: OpenString): PObject;virtual;
    function    KeyAt(I: Integer): String;virtual;
    procedure   Put(Item: PObject; Key: OpenString);virtual;
    function    SwitchTo(AStream: PStream; Pack: Boolean): PStream;virtual;
    procedure   Lock; virtual;
    procedure   UnLock; virtual;
    procedure   DeleteAt(I: Integer);virtual;
    function    GetAt(I: Integer): PObject;virtual;
    function    SearchKey(Key: OpenString; SearchMode: TSearchMode): Integer;
                          virtual;
  private
    IndexPos     : Longint;
    Index        : PObjectCollection;
    mIndex       : PObjectCollection;
    Header       : Pointer;
    SearchPos    : Integer;
    mStream      : PStream;
  end;

const

{ TStream access modes }

  stOpenShared      = $3DC2;           { Read and write access }

  stShareError      = -7;              { Access error }
  stLockError       = -8;              { Lock stream error}
  stUnLockError     = -9;              { UnLock stream error}

function    Lock(Handle: Word; Pos, Size: LongInt): Word;
function    UnLock(Handle: Word; Pos, Size: LongInt): Word;
{$IFNDEF WINDOWS}
function    SetHandleCount(I: Integer): Boolean;
{$ENDIF WINDOWS}

implementation
uses
    WinDos,
    Strings;

const
  RStreamMagic: array[0..14] of Char = 'Object Base''96 ';

{ Private resource manager types }

type

  THeader = record
    Signature : array[0..14] of Char;
    IndexPos  : LongInt;
    Stay      : Word;
  end;

  PObjectItem = ^TObjectItem;
  TObjectItem = record
    Pos: Longint;
    Size: Longint;
    Key: String;
  end;


{ TObjectCollection }

procedure TObjectCollection.FreeItem(Item: Pointer);
begin
  FreeMem(Item, Length(PObjectItem(Item)^.Key) +
    (SizeOf(TObjectItem) - SizeOf(String) + 1));
end;

function TObjectCollection.GetItem(var S: TStream): Pointer;
var
  Pos: Longint;
  Size: Longint;
  L: Byte;
  P: PObjectItem;
begin
  S.Read(Pos, SizeOf(Longint));
  S.Read(Size, SizeOf(Longint));
  S.Read(L, 1);
  GetMem(P, L + (SizeOf(TObjectItem) - SizeOf(String) + 1));
  P^.Pos := Pos;
  P^.Size := Size;
  P^.Key[0] := Char(L);
  S.Read(P^.Key[1], L);
  GetItem := P;
end;

function TObjectCollection.KeyOf(Item: Pointer): Pointer;
begin
  KeyOf := @PObjectItem(Item)^.Key;
end;

procedure TObjectCollection.PutItem(var S: TStream; Item: Pointer);
begin
  S.Write(PObjectItem(Item)^, Length(PObjectItem(Item)^.Key) +
    (SizeOf(TObjectItem) - SizeOf(String) + 1));
end;

{ TObjectBase }

constructor TObjectBase.Init(AStream: PStream;
                             sPage: LongInt);
begin
  inherited Init;
  Stream := AStream;
  Modified    := False;
  Status      := 0;
  ErrorInfo   := 0;
  Page        := sPage;
  Index       := nil;
  mIndex      := nil;
  Header      := nil;
  mStream     := nil;

  GetMem(Header,(SizeOf(THeader) div 16 + 1) * 16);
  if Stream^.GetSize >= SizeOf(THeader) then
  begin
    Stream^.Seek(0);
    Stream^.Read(Header^, SizeOf(THeader));
    with THeader(Header^) do
     if Signature <> RStreamMagic then
     begin
       Status := stInitError;
       Exit;
     end;
    IndexPos := THeader(Header^).IndexPos;
    if THeader(Header^).IndexPos <> 0 then
    begin
      Stream^.Seek(THeader(Header^).IndexPos);
      Index := New(PObjectCollection,Load(Stream^));
    end else
    begin
      IndexPos := SizeOf(THeader);
      Index := New(PObjectCollection,Init(0, 8));
      Modified := True;
    end;
    Error(Stream^.Status, Stream^.ErrorInfo);
   end
  else
   begin
     Index := New(PObjectCollection,Init(0, 8));
     Index^.Duplicates := True;
     StrCopy(THeader(Header^).Signature, RStreamMagic);
     THeader(Header^).IndexPos  := 0;
     THeader(Header^).Stay      := 2*MaxInt;
     Stream^.Seek(0);
     Stream^.Write(Header^, SizeOf(THeader));
     IndexPos := SizeOf(THeader);
     Modified := True;
     Error(Stream^.Status, Stream^.ErrorInfo);
   end;
  mStream := New(PMemoryStream, Init(0,0));
  mIndex := New(PObjectCollection, Init(0, 8));
  mIndex^.Duplicates := True;
end;

destructor  TObjectBase.Done;
begin
  Flush;
  if Assigned(mStream) then Dispose(mStream, Done);
  if Assigned(Index) then Dispose(Index,Done);
  if Assigned(mIndex) then Dispose(mIndex,Done);
  if Assigned(Stream) then Dispose(Stream, Done);
  FreeMem(Header,(SizeOf(THeader) div 16 + 1) * 16);
end;
procedure   TObjectBase.Error(sStatus, sErrorInfo : Integer);
begin
  if sStatus = 0 then Exit;
  Status    := sStatus;
  ErrorInfo := sErrorInfo;
end;
procedure   TObjectBase.Reset;
begin
  if Assigned(Stream)  then Stream^.Reset;
  if Assigned(mStream) then mStream^.Reset;
  Status    := 0;
  ErrorInfo := 0;
end;
function    TObjectBase.Count: Integer;
begin
  Count := Index^.Count+mIndex^.Count;
end;

procedure   TObjectBase.Delete(Key: String);
var
  I: Integer;
begin
  while Index^.Search(@Key, I) do
  begin
    Index^.Free(Index^.At(I));
    Modified := True;
  end;
  while mIndex^.Search(@Key, I) do
    mIndex^.Free(mIndex^.At(I));

  Error(Stream^.Status, Stream^.ErrorInfo);
end;
function    TObjectBase.Get(Key: String): PObject;
var
  I: Integer;
  F: Boolean;
begin
  F   := False;
  Get := nil;
  if Index^.Search(@Key, I) then
  begin
    Stream^.Seek(PObjectItem(Index^.At(I))^.Pos);
    Get := Stream^.Get;
    Error(Stream^.Status, Stream^.ErrorInfo);
    F := True;
  end;
  if not F then
  if mIndex^.Search(@Key, I) then
  begin
    mStream^.Seek(PObjectItem(mIndex^.At(I))^.Pos);
    Get := mStream^.Get;
    Error(mStream^.Status, mStream^.ErrorInfo);
  end;
end;
procedure   TObjectBase.DeleteAt(I: Integer);
begin
  if (I >= 0) and (I < Index^.Count) then
   begin
    Index^.Free(Index^.At(I));
    Modified := True;
   end
  else
   if (I - Index^.Count >= 0) and (I - Index^.Count < mIndex^.Count) then
    mIndex^.Free(mIndex^.At(I - Index^.Count));
end;
function    TObjectBase.GetAt(I: Integer): PObject;
begin
  GetAt := nil;
  if (I >= 0) and (I < Index^.Count) then
   begin
    Stream^.Seek(PObjectItem(Index^.At(I))^.Pos);
    GetAt := Stream^.Get;
    Error(Stream^.Status, Stream^.ErrorInfo);
   end
  else
   if (I - Index^.Count >= 0) and (I - Index^.Count < mIndex^.Count) then
   begin
    mStream^.Seek(PObjectItem(mIndex^.At(I - Index^.Count))^.Pos);
    GetAt := mStream^.Get;
    Error(mStream^.Status, mStream^.ErrorInfo);
   end
end;

function    TObjectBase.SearchKey(Key: OpenString;
                                 SearchMode : TSearchMode) : Integer;
var Item : PObjectItem;
var I    : Integer;
begin

  SearchKey := -1;

  if SearchMode = mSearchFirst then
    for I := 0 to Index^.Count-1 do
    begin
      Item := Index^.At(I);
      if Key <> Item^.Key then Continue;
      SearchPos := I;
      SearchKey := I;
      Break;
    end
   else
    begin
    for I := SearchPos+1 to Index^.Count-1 do
    begin
      Item := Index^.At(I);
      if Key <> Item^.Key then Continue;
      SearchPos := I;
      SearchKey := I;
      Exit;
    end;
    for I := SearchPos-Index^.Count+1 to mIndex^.Count-1 do
    begin
      Item := mIndex^.At(I);
      if Key <> Item^.Key then Continue;
      SearchPos := I;
      SearchKey := I;
      Break;
    end;
    end;
end;

function    TObjectBase.Refresh : Boolean;
var H   : THeader;
begin
  Refresh := False;
  Stream^.Seek(0);
  Stream^.Read(H, SizeOf(THeader));
  if THeader(Header^).Stay <> H.Stay then
  begin
    THeader(Header^) := H;
    IndexPos := THeader(Header^).IndexPos;
    Stream^.Seek(IndexPos);
    Index^.Load(Stream^);
    Refresh := True;
  end;
  Error(Stream^.Status, Stream^.ErrorInfo);
end;


function    TObjectBase.KeyAt(I: Integer): String;
begin
  if (I >= 0) and (I < Index^.Count) then
     KeyAt := PObjectItem(Index^.At(I))^.Key
  else
   if (I - Index^.Count >= 0) and (I - Index^.Count < mIndex^.Count) then
     KeyAt := PObjectItem(mIndex^.At(I - Index^.Count))^.Key
   else KeyAt := '';
end;

procedure   TObjectBase.Put(Item: PObject; Key: String);
var
  P   : PObjectItem;
begin
  if not Assigned(Item) then Exit;
  GetMem(P, Length(Key) + (SizeOf(TObjectItem) - SizeOf(String) + 1));
  mIndex^.Insert(P);
  P^.Key := Key;

  P^.Pos := mStream^.GetPos;
  mStream^.Put(Item);
  P^.Size  := mStream^.GetPos - P^.Pos;
  Modified := True;
  while mStream^.GetPos >= Page * 1024 do Flush;
  Error(mStream^.Status, mStream^.ErrorInfo);
end;

procedure   TObjectBase.Flush;
 procedure DoCopyObject(Item: PObjectItem); far;
 begin
  mStream^.Seek(Item^.Pos);
  Item^.Pos := Stream^.GetPos;
  Stream^.CopyFrom(mStream^, Item^.Size);
  Index^.Insert(Item);
 end;
begin
  if Modified then
  begin
    Stream^.Seek(Stream^.GetSize);
    mIndex^.ForEach(@DoCopyObject);
    mStream^.Seek(0);
    mIndex^.DeleteAll;
    IndexPos := Stream^.GetPos;
    Index^.Pack;
    Index^.Store(Stream^);
    Stream^.Flush;
    if THeader(Header^).Stay = MaxInt*2
             then THeader(Header^).Stay := 0
             else Inc(THeader(Header^).Stay);
    Stream^.Seek(0);
    THeader(Header^).IndexPos := IndexPos;
    Stream^.Write(Header^, SizeOf(THeader));
    Stream^.Flush;
    Modified := False;
  end;
end;
function    TObjectBase.SwitchTo(AStream: PStream; Pack: Boolean): PStream;

procedure DoCopyObject(Item: PObjectItem); far;
begin
  Stream^.Seek(Item^.Pos);
  Item^.Pos := AStream^.GetPos;
  AStream^.CopyFrom(Stream^, Item^.Size);
end;

begin
  Flush;
  SwitchTo := Stream;
  if Pack then
  begin
    AStream^.Seek(0);
    AStream^.Write(Header^, SizeOf(THeader));
    Index^.ForEach(@DoCopyObject);
    AStream^.Truncate;
  end else
  begin
    Stream^.Seek(0);
    AStream^.CopyFrom(Stream^, IndexPos);
    AStream^.Truncate;
  end;
  Error(Stream^.Status, Stream^.ErrorInfo);
  Stream := AStream;
  Modified := True;
end;

procedure   TObjectBase.Lock;
begin
  if OBase.Lock(PDosStream(Stream)^.Handle,MaxLongInt-1,1) <> 0 then
     Error(stShareError, stLockError)
   else Refresh;
end;
procedure   TObjectBase.UnLock;
begin
  if OBase.UnLock(PDosStream(Stream)^.Handle,MaxLongInt-1,1) <> 0 then
     Error(stShareError, stLockError);
  Flush;
end;

function    Lock(Handle: Word; Pos, Size: LongInt): Word;assembler;
asm
        MOV   AX,$5C00
        MOV   BX,Handle
        MOV   CX,Pos.Word[2]
        MOV   DX,Pos.Word[0]
        MOV   SI,Size.Word[2]
        MOV   DI,Size.Word[0]
        INT   21H
        JC    @ERROR
        MOV   AX, 0
@ERROR:
end;
function    UnLock(Handle: Word; Pos, Size: LongInt): Word;assembler;
asm
        MOV   AX,$5C01
        MOV   BX,Handle
        MOV   CX,Pos.Word[2]
        MOV   DX,Pos.Word[0]
        MOV   SI,Size.Word[2]
        MOV   DI,Size.Word[0]
        INT   21H
        JC    @ERROR
        MOV   AX, 0
@ERROR:
end;

{$IFNDEF WINDOWS}
function    SetHandleCount(I: Integer): Boolean;assembler;
asm
        MOV   AH, 67H
        MOV   BX, I
        INT   21H
        JC    @ERROR
        MOV   AX, 1
        JMP   @OK
@ERROR:
        MOV   AX, 0
@OK:
end;
{$ENDIF WINDOWS}

end.


